diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-activate.php ./wordpress-3.3/wp-activate.php
*** ./wordpress-3.2.1/wp-activate.php	2011-11-24 20:39:25.000000000 -0600
--- ./wordpress-3.3/wp-activate.php	2011-10-20 09:40:11.000000000 -0500
***************
*** 63,71 ****
  				<?php
  				echo '<p class="lead-in">';
  				if ( $signup->domain . $signup->path == '' ) {
! 					printf( __('Your account has been activated. You may now <a href="%1$s">log in</a> to the site using your chosen username of &#8220;%2$s&#8221;.  Please check your email inbox at %3$s for your password and login instructions. If you do not receive an email, please check your junk or spam folder. If you still do not receive an email within an hour, you can <a href="%4$s">reset your password</a>.'), network_site_url( 'wp-login.php', 'login' ), $signup->user_login, $signup->user_email, network_site_url( 'wp-login.php?action=lostpassword', 'login' ) );
  				} else {
! 					printf( __('Your site at <a href="%1$s">%2$s</a> is active. You may now log in to your site using your chosen username of &#8220;%3$s&#8221;.  Please check your email inbox at %4$s for your password and login instructions.  If you do not receive an email, please check your junk or spam folder.  If you still do not receive an email within an hour, you can <a href="%5$s">reset your password</a>.'), 'http://' . $signup->domain, $signup->domain, $signup->user_login, $signup->user_email, network_site_url( 'wp-login.php?action=lostpassword' ) );
  				}
  				echo '</p>';
  			} else {
--- 63,71 ----
  				<?php
  				echo '<p class="lead-in">';
  				if ( $signup->domain . $signup->path == '' ) {
! 					printf( __('Your account has been activated. You may now <a href="%1$s">log in</a> to the site using your chosen username of &#8220;%2$s&#8221;.  Please check your email inbox at %3$s for your password and login instructions. If you do not receive an email, please check your junk or spam folder. If you still do not receive an email within an hour, you can <a href="%4$s">reset your password</a>.'), network_site_url( 'wp-login.php', 'login' ), $signup->user_login, $signup->user_email, wp_lostpassword_url() );
  				} else {
! 					printf( __('Your site at <a href="%1$s">%2$s</a> is active. You may now log in to your site using your chosen username of &#8220;%3$s&#8221;.  Please check your email inbox at %4$s for your password and login instructions.  If you do not receive an email, please check your junk or spam folder.  If you still do not receive an email within an hour, you can <a href="%5$s">reset your password</a>.'), 'http://' . $signup->domain, $signup->domain, $signup->user_login, $signup->user_email, wp_lostpassword_url() );
  				}
  				echo '</p>';
  			} else {
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/about.php ./wordpress-3.3/wp-admin/about.php
*** ./wordpress-3.2.1/wp-admin/about.php	1969-12-31 18:00:00.000000000 -0600
--- ./wordpress-3.3/wp-admin/about.php	2011-12-02 11:17:08.000000000 -0600
***************
*** 0 ****
--- 1,201 ----
+ <?php
+ /**
+  * About This Version administration panel.
+  *
+  * @package WordPress
+  * @subpackage Administration
+  */
+ 
+ /** WordPress Administration Bootstrap */
+ require_once( './admin.php' );
+ 
+ $title = __( 'About' );
+ 
+ list( $display_version ) = explode( '-', $wp_version );
+ 
+ include( './admin-header.php' );
+ ?>
+ <div class="wrap about-wrap">
+ 
+ <h1><?php printf( __( 'Welcome to WordPress %s' ), $display_version ); ?></h1>
+ 
+ <div class="about-text"><?php printf( __( 'Thank you for updating to the latest version! Using WordPress %s will improve your looks, personality, and web publishing experience. Okay, just the last one, but still. :)' ), $display_version ); ?></div>
+ 
+ <div class="wp-badge"><?php printf( __( 'Version %s' ), $display_version ); ?></div>
+ 
+ <h2 class="nav-tab-wrapper">
+ 	<a href="about.php" class="nav-tab nav-tab-active">
+ 		<?php _e( 'What&#8217;s New' ); ?>
+ 	</a><a href="credits.php" class="nav-tab">
+ 		<?php _e( 'Credits' ); ?>
+ 	</a><a href="freedoms.php" class="nav-tab">
+ 		<?php _e( 'Freedoms' ); ?>
+ 	</a>
+ </h2>
+ 
+ <div class="changelog">
+ 	<h3><?php _e( 'Easier Uploading' ); ?></h3>
+ 
+ 	<div class="feature-section images-stagger-right">
+ 		<div class="feature-images">
+ 			<img src="images/screenshots/media-icon.png" width="200" class="angled-right" />
+ 			<img src="images/screenshots/drag-and-drop.png" width="200" class="angled-left" />
+ 		</div>
+ 		<div class="left-feature">
+ 			<h4><?php _e( 'File Type Detection' ); ?></h4>
+ 			<p><?php _e( 'We&#8217;ve streamlined things! Instead of needing to click on a specific upload icon based on your file type, now there&#8217;s just one. Once your file is uploaded, the appropriate fields will be displayed for entering information based on the file type.' ); ?></p>
+ 
+ 			<h4><?php _e( 'Drag-and-Drop Media Uploader' ); ?></h4>
+ 			<p><?php _e( 'Adding photos or other files to posts and pages just got easier. Drag files from your desktop and drop them into the uploader. Add one file at a time, or many at once.' ); ?></p>
+ 
+ 			<h4><?php _e( 'More File Formats' ); ?></h4>
+ 			<p><?php _e( 'We&#8217;ve added the rar and 7z file formats to the list of allowed file types in the uploader.' ); ?></p>
+ 		</div>
+ 	</div>
+ </div>
+ 
+ <div class="changelog">
+ 	<h3><?php _e( 'Dashboard Design' ); ?></h3>
+ 
+ 	<div class="feature-section text-features">
+ 		<h4><?php _e( 'Flyout Menus' ); ?></h4>
+ 		<p><?php _e( 'Speed up navigating the dashboard and reduce repetitive clicking with our new flyout submenus. As you hover over each main menu item in your dashboard navigation, the submenus will magically appear, providing single-click access to any dashboard screen.' ); ?></p>
+ 
+ 		<div>
+ 		<h4><?php _e( 'Header + Admin Bar = Toolbar' ); ?></h4>
+ 		<p><?php _e( 'To save space and increase efficiency, we&#8217;ve combined the admin bar and the old Dashboard header into one persistent toolbar. Hovering over the toolbar items will reveal submenus when available for quick access. ' ); ?></p>
+ 		</div>
+ 	</div>
+ 
+ 	<div class="feature-section screenshot-features">
+ 		<div class="angled-left">
+ 			<img src="images/screenshots/admin-flyouts.png" />
+ 			<h4><?php _e( 'Responsive Design' ); ?></h4>
+ 			<p><?php _e( 'Certain dashboard screens have been updated to look better at various sizes, including improved iPad/tablet support.' ); ?></p>
+ 		</div>
+ 		<div class="angled-right">
+ 			<img src="images/screenshots/help-screen.png" />
+ 			<h4><?php _e( 'Help Tabs' ); ?></h4>
+ 			<p><?php _e( 'The Help tabs located in the upper corner of the dashboard screens below your name have gotten a facelift. Help content is broken into smaller sections for easier access, with links to relevant documentation and the support forums always visible.' ); ?></p>
+ 		</div>
+ 	</div>
+ </div>
+ 
+ <div class="changelog">
+ 	<h3><?php _e( 'Feels Like the First Time' ); ?></h3>
+ 
+ 	<div class="feature-section images-stagger-right">
+ 		<div class="feature-images">
+ 			<img src="images/screenshots/new-feature-pointer.png" class="angled-right" />
+ 			<img src="images/screenshots/welcome-screen.png" class="angled-left" />
+ 		</div>
+ 		<div class="left-feature">
+ 			<h4><?php _e( 'New Feature Pointers' ); ?></h4>
+ 			<p><?php _e( 'When we add new features, move navigation, or do anything else with the dashboard that might throw you for a loop when you update your WordPress site, we&#8217;ll let you know about it with new feature pointers explaining the change.' ); ?></p>
+ 
+ 			<h4><?php _e( 'Post-update Changelog' ); ?></h4>
+ 			<p><?php _e( 'This screen! From now on when you update WordPress, you&#8217;ll be brought to this screen &mdash; also accessible any time from the W logo in the corner of the toolbar &mdash; to get an overview of what&#8217;s changed.' ); ?></p>
+ 
+ 			<h4><?php _e( 'Dashboard Welcome' ); ?></h4>
+ 			<p><?php _e( 'The dashboard home screen will have a Welcome area that displays when a new WordPress installation is accessed for the first time, prompting the site owner to complete various setup tasks. Once dismissed, this welcome can be accessed via the dashboard home screen options tab.' ); ?></p>
+ 		</div>
+ 	</div>
+ 
+ </div>
+ 
+ <div class="changelog">
+ 	<h3><?php _e( 'Content Tools' ); ?></h3>
+ 
+ 	<div class="feature-section three-col">
+ 		<div>
+ 			<h4><?php _e( 'Better Co-Editing' ); ?></h4>
+ 			<img src="images/screenshots/coediting.png" class="element-screenshot" />
+ 			<p><?php _e( 'Have you ever gone to edit a post after someone else has finished with it, only to get an alert that tells you the other person is still editing the post? From now on, you&#8217;ll only get that alert if another person is still on the editing screen &mdash; no more time lag.' ); ?></p>
+ 		</div>
+ 		<div>
+ 			<h4><?php _e( 'Tumblr Importer' ); ?></h4>
+ 			<p><?php _e( 'Want to import content from Tumblr to WordPress? No problem! Go to <span class="no-break">Tools &rarr; Import</span> to get the new Tumblr Importer, which maps your Tumblog posts to the matching WordPress post formats. Tip: Choose a theme designed to display post formats to get the greatest benefit from the importer.' ); ?></p>
+ 		</div>
+ 		<div class="last-feature">
+ 			<h4><?php _e( 'Widget Improvements' ); ?></h4>
+ 			<p><?php _e( 'Changing themes often requires widget re-configuration based on the number and position of sidebars. Now if you change back to a previous theme, the widgets will automatically go back to how you had them arranged in that theme. <em>Note: if you&#8217;ve added new widgets since the switch, you&#8217;ll need to rescue them from the Inactive Widgets area.</em>' ); ?></p>
+ 		</div>
+ 	</div>
+ 
+ </div>
+ 
+ <div class="changelog">
+ 	<h3><?php _e( 'Under the Hood' ); ?></h3>
+ 
+ 	<div class="feature-section three-col">
+ 		<div>
+ 			<h4><?php _e( 'Flexible Permalinks' ); ?></h4>
+ 			<p><?php _e( 'You have more freedom when choosing a post permalink structure. Skip the date information or add a category slug without a performance penalty.' ); ?></p>
+ 		</div>
+ 		<div>
+ 			<h4><?php _e( 'Post Slugs: Less Funky' ); ?></h4>
+ 			<p><?php _e( 'Funky characters in post titles (e.g. curly quotes from a word processor) will no longer result in garbled post slugs.' ); ?></p>
+ 		</div>
+ 		<div class="last-feature">
+ 			<h4><?php _e( 'jQuery and jQuery UI' ); ?></h4>
+ 			<p><?php printf( __( 'WordPress now includes the entire jQuery UI stack and the latest version of jQuery: %s.' ), '1.7.1' ); ?></p>
+ 		</div>
+ 	</div>
+ 
+ 	<div class="feature-section three-col">
+ 		<div>
+ 			<h4 style="direction:ltr">is_main_query()</h4>
+ 			<p><?php _e( 'This handy method will tell you if a <code>WP_Query</code> object is the main WordPress query or a secondary query.' ); ?></p>
+ 		</div>
+ 		<div>
+ 			<h4><?php _e( 'WP_Screen API' ); ?></h4>
+ 			<p><?php _e( 'WordPress has a nice new API for working with admin screens. Create rich screens, add help documentation, adapt to screen contexts, and more.' ); ?></p>
+ 		</div>
+ 		<div class="last-feature">
+ 			<h4><?php _e( 'Editor API Overhaul' ); ?></h4>
+ 			<p><?php _e( 'The new editor API automatically pulls in all the JS and CSS goodness for the editor. It even supports multiple editors on the same page.' ); ?></p>
+ 		</div>
+ 	</div>
+ 
+ </div>
+ 
+ <div class="return-to-dashboard">
+ 	<?php if ( current_user_can( 'update_core' ) && isset( $_GET['updated'] ) ) : ?>
+ 	<a href="<?php echo esc_url( network_admin_url( 'update-core.php' ) ); ?>"><?php
+ 		is_multisite() ? _e( 'Return to Updates' ) : _e( 'Return to Dashboard &rarr; Updates' );
+ 	?></a> |
+ 	<?php endif; ?>
+ 	<a href="<?php echo esc_url( admin_url() ); ?>"><?php _e( 'Go to Dashboard &rarr; Home' ); ?></a>
+ </div>
+ 
+ </div>
+ <?php
+ 
+ include( './admin-footer.php' );
+ 
+ // These are strings we may use to describe maintenance/security releases, where we aim for no new strings.
+ return;
+ 
+ _n_noop( 'Maintenance Release', 'Maintenance Releases' );
+ _n_noop( 'Security Release', 'Security Releases' );
+ _n_noop( 'Maintenance and Security Release', 'Maintenance and Security Releases' );
+ 
+ /* translators: 1: WordPress version number. */
+ _n_noop( '<strong>Version %1$s</strong> addressed a security issue.',
+          '<strong>Version %1$s</strong> addressed some security issues.' );
+ 
+ /* translators: 1: WordPress version number, 2: plural number of bugs. */
+ _n_noop( '<strong>Version %1$s</strong> addressed %2$s bug.',
+          '<strong>Version %1$s</strong> addressed %2$s bugs.' );
+ 
+ /* translators: 1: WordPress version number, 2: plural number of bugs. Singular security issue. */
+ _n_noop( '<strong>Version %1$s</strong> addressed a security issue and fixed %2$s bug.',
+          '<strong>Version %1$s</strong> addressed a security issue and fixed %2$s bugs.' );
+ 
+ /* translators: 1: WordPress version number, 2: plural number of bugs. More than one security issue. */
+ _n_noop( '<strong>Version %1$s</strong> addressed some security issues and fixed %2$s bug.',
+          '<strong>Version %1$s</strong> addressed some security issues and fixed %2$s bugs.' );
+ 
+ __( 'For more information, see <a href="%s">the release notes</a>.' );
+ 
+ ?>
\ No newline at end of file
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/admin-ajax.php ./wordpress-3.3/wp-admin/admin-ajax.php
*** ./wordpress-3.2.1/wp-admin/admin-ajax.php	2011-11-24 20:39:25.000000000 -0600
--- ./wordpress-3.3/wp-admin/admin-ajax.php	2011-11-23 13:06:52.000000000 -0600
***************
*** 55,64 ****
  	$list_class = $_GET['list_args']['class'];
  	check_ajax_referer( "fetch-list-$list_class", '_ajax_fetch_list_nonce' );
  
! 	$current_screen = (object) $_GET['list_args']['screen'];
! 	//TODO fix this in a better way see #15336
! 	$current_screen->is_network = 'false' === $current_screen->is_network ? false : true;
! 	$current_screen->is_user = 'false' === $current_screen->is_user ? false : true;
  
  	define( 'WP_NETWORK_ADMIN', $current_screen->is_network );
  	define( 'WP_USER_ADMIN', $current_screen->is_user );
--- 55,61 ----
  	$list_class = $_GET['list_args']['class'];
  	check_ajax_referer( "fetch-list-$list_class", '_ajax_fetch_list_nonce' );
  
! 	$current_screen = convert_to_screen( $_GET['list_args']['screen']['id'] );
  
  	define( 'WP_NETWORK_ADMIN', $current_screen->is_network );
  	define( 'WP_USER_ADMIN', $current_screen->is_user );
***************
*** 321,327 ****
  case 'delete-comment' : // On success, die with time() instead of 1
  	if ( !$comment = get_comment( $id ) )
  		die( (string) time() );
! 	if ( !current_user_can( 'edit_post', $comment->comment_post_ID ) )
  		die('-1');
  
  	check_ajax_referer( "delete-comment_$id" );
--- 318,324 ----
  case 'delete-comment' : // On success, die with time() instead of 1
  	if ( !$comment = get_comment( $id ) )
  		die( (string) time() );
! 	if ( ! current_user_can( 'edit_comment', $comment->comment_ID ) )
  		die('-1');
  
  	check_ajax_referer( "delete-comment_$id" );
***************
*** 393,402 ****
  	break;
  case 'delete-meta' :
  	check_ajax_referer( "delete-meta_$id" );
! 	if ( !$meta = get_post_meta_by_id( $id ) )
  		die('1');
  
! 	if ( !current_user_can( 'edit_post', $meta->post_id ) || is_protected_meta( $meta->meta_key ) )
  		die('-1');
  	if ( delete_meta( $meta->meta_id ) )
  		die('1');
--- 390,399 ----
  	break;
  case 'delete-meta' :
  	check_ajax_referer( "delete-meta_$id" );
! 	if ( !$meta = get_metadata_by_mid( 'post', $id ) )
  		die('1');
  
! 	if ( is_protected_meta( $meta->meta_key, 'post' ) || ! current_user_can( 'delete_post_meta',  $meta->post_id, $meta->meta_key ) )
  		die('-1');
  	if ( delete_meta( $meta->meta_id ) )
  		die('1');
***************
*** 457,463 ****
  		$x->send();
  	}
  
! 	if ( !current_user_can( 'edit_post', $comment->comment_post_ID ) && !current_user_can( 'moderate_comments' ) )
  		die('-1');
  
  	$current = wp_get_comment_status( $comment->comment_ID );
--- 454,460 ----
  		$x->send();
  	}
  
! 	if ( ! current_user_can( 'edit_comment', $comment->comment_ID ) && ! current_user_can( 'moderate_comments' ) )
  		die('-1');
  
  	$current = wp_get_comment_status( $comment->comment_ID );
***************
*** 612,617 ****
--- 609,616 ----
  	$x = new WP_Ajax_Response();
  	ob_start();
  	foreach ( $wp_list_table->items as $comment ) {
+ 		if ( ! current_user_can( 'edit_comment', $comment->comment_ID ) )
+ 			continue;
  		get_comment( $comment );
  		$wp_list_table->single_row( $comment );
  	}
***************
*** 638,644 ****
  	if ( empty($status) )
  		die('1');
  	elseif ( in_array($status, array('draft', 'pending', 'trash') ) )
! 		die( __('Error: you are replying to a comment on a draft post.') );
  
  	$user = wp_get_current_user();
  	if ( $user->ID ) {
--- 637,643 ----
  	if ( empty($status) )
  		die('1');
  	elseif ( in_array($status, array('draft', 'pending', 'trash') ) )
! 		die( __('ERROR: you are replying to a comment on a draft post.') );
  
  	$user = wp_get_current_user();
  	if ( $user->ID ) {
***************
*** 646,653 ****
  		$comment_author_email = $wpdb->escape($user->user_email);
  		$comment_author_url   = $wpdb->escape($user->user_url);
  		$comment_content      = trim($_POST['content']);
! 		if ( current_user_can('unfiltered_html') ) {
! 			if ( wp_create_nonce('unfiltered-html-comment_' . $comment_post_ID) != $_POST['_wp_unfiltered_html_comment'] ) {
  				kses_remove_filters(); // start with a clean slate
  				kses_init_filters(); // set up the filters
  			}
--- 645,652 ----
  		$comment_author_email = $wpdb->escape($user->user_email);
  		$comment_author_url   = $wpdb->escape($user->user_url);
  		$comment_content      = trim($_POST['content']);
! 		if ( current_user_can( 'unfiltered_html' ) ) {
! 			if ( wp_create_nonce( 'unfiltered-html-comment' ) != $_POST['_wp_unfiltered_html_comment'] ) {
  				kses_remove_filters(); // start with a clean slate
  				kses_init_filters(); // set up the filters
  			}
***************
*** 657,663 ****
  	}
  
  	if ( '' == $comment_content )
! 		die( __('Error: please type a comment.') );
  
  	$comment_parent = absint($_POST['comment_ID']);
  	$comment_auto_approved = false;
--- 656,662 ----
  	}
  
  	if ( '' == $comment_content )
! 		die( __('ERROR: please type a comment.') );
  
  	$comment_parent = absint($_POST['comment_ID']);
  	$comment_auto_approved = false;
***************
*** 714,727 ****
  
  	set_current_screen( 'edit-comments' );
  
! 	$comment_post_ID = (int) $_POST['comment_post_ID'];
! 	if ( ! current_user_can( 'edit_post', $comment_post_ID ) )
  		die('-1');
  
  	if ( '' == $_POST['content'] )
! 		die( __('Error: please type a comment.') );
  
- 	$comment_id = (int) $_POST['comment_ID'];
  	$_POST['comment_status'] = $_POST['status'];
  	edit_comment();
  
--- 713,725 ----
  
  	set_current_screen( 'edit-comments' );
  
! 	$comment_id = (int) $_POST['comment_ID'];
! 	if ( ! current_user_can( 'edit_comment', $comment_id ) )
  		die('-1');
  
  	if ( '' == $_POST['content'] )
! 		die( __('ERROR: please type a comment.') );
  
  	$_POST['comment_status'] = $_POST['status'];
  	edit_comment();
  
***************
*** 848,854 ****
  			die(__('Please provide a custom field value.'));
  		}
  
! 		$meta = get_post_meta_by_id( $mid );
  		$pid = (int) $meta->post_id;
  		$meta = get_object_vars( $meta );
  		$x = new WP_Ajax_Response( array(
--- 846,852 ----
  			die(__('Please provide a custom field value.'));
  		}
  
! 		$meta = get_metadata_by_mid( 'post', $mid );
  		$pid = (int) $meta->post_id;
  		$meta = get_object_vars( $meta );
  		$x = new WP_Ajax_Response( array(
***************
*** 859,884 ****
  			'supplemental' => array('postid' => $pid)
  		) );
  	} else { // Update?
! 		$mid = (int) array_pop( array_keys($_POST['meta']) );
! 		$key = $_POST['meta'][$mid]['key'];
! 		$value = $_POST['meta'][$mid]['value'];
  		if ( '' == trim($key) )
  			die(__('Please provide a custom field name.'));
  		if ( '' == trim($value) )
  			die(__('Please provide a custom field value.'));
! 		if ( !$meta = get_post_meta_by_id( $mid ) )
  			die('0'); // if meta doesn't exist
! 		if ( !current_user_can( 'edit_post', $meta->post_id ) )
! 			die('-1');
! 		if ( is_protected_meta( $meta->meta_key ) )
  			die('-1');
! 		if ( $meta->meta_value != stripslashes($value) || $meta->meta_key != stripslashes($key) ) {
! 			if ( !$u = update_meta( $mid, $key, $value ) )
  				die('0'); // We know meta exists; we also know it's unchanged (or DB error, in which case there are bigger problems).
  		}
  
- 		$key = stripslashes($key);
- 		$value = stripslashes($value);
  		$x = new WP_Ajax_Response( array(
  			'what' => 'meta',
  			'id' => $mid, 'old_id' => $mid,
--- 857,880 ----
  			'supplemental' => array('postid' => $pid)
  		) );
  	} else { // Update?
! 		$mid = (int) key( $_POST['meta'] );
! 		$key = stripslashes( $_POST['meta'][$mid]['key'] );
! 		$value = stripslashes( $_POST['meta'][$mid]['value'] );
  		if ( '' == trim($key) )
  			die(__('Please provide a custom field name.'));
  		if ( '' == trim($value) )
  			die(__('Please provide a custom field value.'));
! 		if ( ! $meta = get_metadata_by_mid( 'post', $mid ) )
  			die('0'); // if meta doesn't exist
! 		if ( is_protected_meta( $meta->meta_key, 'post' ) || is_protected_meta( $key, 'post' ) ||
! 			! current_user_can( 'edit_post_meta', $meta->post_id, $meta->meta_key ) ||
! 			! current_user_can( 'edit_post_meta', $meta->post_id, $key ) )
  			die('-1');
! 		if ( $meta->meta_value != $value || $meta->meta_key != $key ) {
! 			if ( !$u = update_metadata_by_mid( 'post', $mid, $value, $key ) )
  				die('0'); // We know meta exists; we also know it's unchanged (or DB error, in which case there are bigger problems).
  		}
  
  		$x = new WP_Ajax_Response( array(
  			'what' => 'meta',
  			'id' => $mid, 'old_id' => $mid,
***************
*** 983,1002 ****
  		}
  		$data = $message;
  	} else {
! 		if ( isset( $_POST['auto_draft'] ) && '1' == $_POST['auto_draft'] )
  			$id = 0; // This tells us it didn't actually save
  		else
  			$id = $post->ID;
  	}
  
! 	if ( $do_lock && ( isset( $_POST['auto_draft'] ) && ( $_POST['auto_draft'] != '1' ) ) && $id && is_numeric($id) )
! 		wp_set_post_lock( $id );
  
  	if ( $nonce_age == 2 ) {
  		$supplemental['replace-autosavenonce'] = wp_create_nonce('autosave');
  		$supplemental['replace-getpermalinknonce'] = wp_create_nonce('getpermalink');
  		$supplemental['replace-samplepermalinknonce'] = wp_create_nonce('samplepermalink');
  		$supplemental['replace-closedpostboxesnonce'] = wp_create_nonce('closedpostboxes');
  		if ( $id ) {
  			if ( $_POST['post_type'] == 'post' )
  				$supplemental['replace-_wpnonce'] = wp_create_nonce('update-post_' . $id);
--- 979,1001 ----
  		}
  		$data = $message;
  	} else {
! 		if ( ! empty( $_POST['auto_draft'] ) )
  			$id = 0; // This tells us it didn't actually save
  		else
  			$id = $post->ID;
  	}
  
! 	if ( $do_lock && empty( $_POST['auto_draft'] ) && $id && is_numeric( $id ) ) {
! 		$lock_result = wp_set_post_lock( $id );
! 		$supplemental['active-post-lock'] = implode( ':', $lock_result );
! 	}
  
  	if ( $nonce_age == 2 ) {
  		$supplemental['replace-autosavenonce'] = wp_create_nonce('autosave');
  		$supplemental['replace-getpermalinknonce'] = wp_create_nonce('getpermalink');
  		$supplemental['replace-samplepermalinknonce'] = wp_create_nonce('samplepermalink');
  		$supplemental['replace-closedpostboxesnonce'] = wp_create_nonce('closedpostboxes');
+ 		$supplemental['replace-_ajax_linking_nonce'] = wp_create_nonce( 'internal-linking' );
  		if ( $id ) {
  			if ( $_POST['post_type'] == 'post' )
  				$supplemental['replace-_wpnonce'] = wp_create_nonce('update-post_' . $id);
***************
*** 1026,1033 ****
  
  	$page = isset( $_POST['page'] ) ? $_POST['page'] : '';
  
! 	if ( !preg_match( '/^[a-z_-]+$/', $page ) )
! 		die('-1');
  
  	if ( ! $user = wp_get_current_user() )
  		die('-1');
--- 1025,1032 ----
  
  	$page = isset( $_POST['page'] ) ? $_POST['page'] : '';
  
! 	if ( $page != sanitize_key( $page ) )
! 		die('0');
  
  	if ( ! $user = wp_get_current_user() )
  		die('-1');
***************
*** 1048,1055 ****
  	$hidden = explode( ',', $_POST['hidden'] );
  	$page = isset( $_POST['page'] ) ? $_POST['page'] : '';
  
! 	if ( !preg_match( '/^[a-z_-]+$/', $page ) )
! 		die('-1');
  
  	if ( ! $user = wp_get_current_user() )
  		die('-1');
--- 1047,1054 ----
  	$hidden = explode( ',', $_POST['hidden'] );
  	$page = isset( $_POST['page'] ) ? $_POST['page'] : '';
  
! 	if ( $page != sanitize_key( $page ) )
! 		die('0');
  
  	if ( ! $user = wp_get_current_user() )
  		die('-1');
***************
*** 1059,1064 ****
--- 1058,1073 ----
  
  	die('1');
  	break;
+ case 'update-welcome-panel' :
+ 	check_ajax_referer( 'welcome-panel-nonce', 'welcomepanelnonce' );
+ 
+ 	if ( ! current_user_can( 'edit_theme_options' ) )
+ 		die('-1');
+ 
+ 	update_user_meta( get_current_user_id(), 'show_welcome_panel', empty( $_POST['visible'] ) ? 0 : 1 );
+ 
+ 	die('1');
+ 	break;
  case 'menu-get-metabox' :
  	if ( ! current_user_can( 'edit_theme_options' ) )
  		die('-1');
***************
*** 1109,1116 ****
  	exit;
  	break;
  case 'wp-link-ajax':
- 	require_once ABSPATH . 'wp-admin/includes/internal-linking.php';
- 
  	check_ajax_referer( 'internal-linking', '_ajax_linking_nonce' );
  
  	$args = array();
--- 1118,1123 ----
***************
*** 1119,1125 ****
  		$args['s'] = stripslashes( $_POST['search'] );
  	$args['pagenum'] = ! empty( $_POST['page'] ) ? absint( $_POST['page'] ) : 1;
  
! 	$results = wp_link_query( $args );
  
  	if ( ! isset( $results ) )
  		die( '0' );
--- 1126,1133 ----
  		$args['s'] = stripslashes( $_POST['search'] );
  	$args['pagenum'] = ! empty( $_POST['page'] ) ? absint( $_POST['page'] ) : 1;
  
! 	require(ABSPATH . WPINC . '/class-wp-editor.php');
! 	$results = _WP_Editors::wp_link_query( $args );
  
  	if ( ! isset( $results ) )
  		die( '0' );
***************
*** 1141,1151 ****
  case 'meta-box-order':
  	check_ajax_referer( 'meta-box-order' );
  	$order = isset( $_POST['order'] ) ? (array) $_POST['order'] : false;
! 	$page_columns = isset( $_POST['page_columns'] ) ? (int) $_POST['page_columns'] : 0;
  	$page = isset( $_POST['page'] ) ? $_POST['page'] : '';
  
! 	if ( !preg_match( '/^[a-z_-]+$/', $page ) )
! 		die('-1');
  
  	if ( ! $user = wp_get_current_user() )
  		die('-1');
--- 1149,1163 ----
  case 'meta-box-order':
  	check_ajax_referer( 'meta-box-order' );
  	$order = isset( $_POST['order'] ) ? (array) $_POST['order'] : false;
! 	$page_columns = isset( $_POST['page_columns'] ) ? $_POST['page_columns'] : 'auto';
! 
! 	if ( $page_columns != 'auto' )
! 		$page_columns = (int) $page_columns;
! 
  	$page = isset( $_POST['page'] ) ? $_POST['page'] : '';
  
! 	if ( $page != sanitize_key( $page ) )
! 		die('0');
  
  	if ( ! $user = wp_get_current_user() )
  		die('-1');
***************
*** 1471,1478 ****
  	check_ajax_referer( "set_post_thumbnail-$post_ID" );
  
  	if ( $thumbnail_id == '-1' ) {
! 		delete_post_meta( $post_ID, '_thumbnail_id' );
! 		die( _wp_post_thumbnail_html() );
  	}
  
  	if ( set_post_thumbnail( $post_ID, $thumbnail_id ) )
--- 1483,1492 ----
  	check_ajax_referer( "set_post_thumbnail-$post_ID" );
  
  	if ( $thumbnail_id == '-1' ) {
! 		if ( delete_post_thumbnail( $post_ID ) )
! 			die( _wp_post_thumbnail_html() );
! 		else
! 			die( '0' );
  	}
  
  	if ( set_post_thumbnail( $post_ID, $thumbnail_id ) )
***************
*** 1486,1517 ****
  	die( date_i18n( sanitize_option( 'time_format', $_POST['date'] ) ) );
  	break;
  case 'wp-fullscreen-save-post' :
! 	if ( isset($_POST['post_ID']) )
! 		$post_id = (int) $_POST['post_ID'];
! 	else
! 		$post_id = 0;
  
! 	$post = null;
! 	$post_type_object = null;
! 	$post_type = null;
! 	if ( $post_id ) {
! 		$post = get_post($post_id);
! 		if ( $post ) {
! 			$post_type_object = get_post_type_object($post->post_type);
! 			if ( $post_type_object ) {
! 				$post_type = $post->post_type;
! 				$current_screen->post_type = $post->post_type;
! 				$current_screen->id = $current_screen->post_type;
! 			}
! 		}
! 	} elseif ( isset($_POST['post_type']) ) {
! 		$post_type_object = get_post_type_object($_POST['post_type']);
! 		if ( $post_type_object ) {
! 			$post_type = $post_type_object->name;
! 			$current_screen->post_type = $post_type;
! 			$current_screen->id = $current_screen->post_type;
! 		}
! 	}
  
  	check_ajax_referer('update-' . $post_type . '_' . $post_id, '_wpnonce');
  
--- 1500,1516 ----
  	die( date_i18n( sanitize_option( 'time_format', $_POST['date'] ) ) );
  	break;
  case 'wp-fullscreen-save-post' :
! 	$post_id = isset( $_POST['post_ID'] ) ? (int) $_POST['post_ID'] : 0;
  
! 	$post = $post_type = null;
! 
! 	if ( $post_id )
! 		$post = get_post( $post_id );
! 
! 	if ( $post )
! 		$post_type = $post->post_type;
! 	elseif ( isset( $_POST['post_type'] ) && post_type_exists( $_POST['post_type'] ) )
! 		$post_type = $_POST['post_type'];
  
  	check_ajax_referer('update-' . $post_type . '_' . $post_id, '_wpnonce');
  
***************
*** 1547,1552 ****
--- 1546,1588 ----
  	echo json_encode( array( 'message' => $message, 'last_edited' => $last_edited ) );
  	die();
  	break;
+ case 'wp-remove-post-lock' :
+ 	if ( empty( $_POST['post_ID'] ) || empty( $_POST['active_post_lock'] ) )
+ 		die( '0' );
+ 	$post_id = (int) $_POST['post_ID'];
+ 	if ( ! $post = get_post( $post_id ) )
+ 		die( '0' );
+ 
+ 	check_ajax_referer( 'update-' . $post->post_type . '_' . $post_id );
+ 
+ 	if ( ! current_user_can( 'edit_post', $post_id ) )
+ 		die( '-1' );
+ 
+ 	$active_lock = array_map( 'absint', explode( ':', $_POST['active_post_lock'] ) );
+ 	if ( $active_lock[1] != get_current_user_id() )
+ 		die( '0' );
+ 
+ 	$new_lock = ( time() - apply_filters( 'wp_check_post_lock_window', AUTOSAVE_INTERVAL * 2 ) + 5 ) . ':' . $active_lock[1];
+ 	update_post_meta( $post_id, '_edit_lock', $new_lock, implode( ':', $active_lock ) );
+ 	die( '1' );
+ case 'dismiss-wp-pointer' :
+ 	$pointer = $_POST['pointer'];
+ 	if ( $pointer != sanitize_key( $pointer ) )
+ 		die( '0' );
+ 
+ //	check_ajax_referer( 'dismiss-pointer_' . $pointer );
+ 
+ 	$dismissed = array_filter( explode( ',', (string) get_user_meta( get_current_user_id(), 'dismissed_wp_pointers', true ) ) );
+ 
+ 	if ( in_array( $pointer, $dismissed ) )
+ 		die( '0' );
+ 
+ 	$dismissed[] = $pointer;
+ 	$dismissed = implode( ',', $dismissed );
+ 
+ 	update_user_meta( get_current_user_id(), 'dismissed_wp_pointers', $dismissed );
+ 	die( '1' );
+ 	break;
  default :
  	do_action( 'wp_ajax_' . $_POST['action'] );
  	die('0');
